/* MAC 440 - EP 3 - "MUD Distribuido (TCB)"

   Nomes: Andr Gustavo Andrade         #3117621
          Julio Cesar Avero             #3188339

   Ferramentas: JacORB1_4_beta2, jakarta-ant-1.4.1, j2sdk1.4.0
   
   Data Incio:            15/06
   Data Ultima Alterao:  16/06
*/

/* TODO: -> Implementar o sistema de Autenticacao
         -> Formas do usuario entrar com a descricao de seu avatar
*/
package MUD;

import java.io.*;
import java.lang.*;
import java.util.*;
import org.omg.PortableServer.*;
import org.omg.CORBA.*;

/** Classe cliente. Inicializa o controle (acesso) e o player (servente)*/
public class Cliente 
{
    /** Esta eh a rotina principal do programa, sendo responsavel por 
	Instanciar o OD do controle, o OD da clareira e o servante do 
	Avatar com o qual aquele usuario ira encarnar no MUD
	@param args Argumentos coletados na linha de comando. O argumento
	<code>args[0]</code> refere-se ao arquivo contendo a 
	referencia do controle. Isso pode ser disponibilizado 
	na net entre grupos de jogadores.
	O <code>args[1]</code>  o nome do Avatar por enquanto. 
	Futuramente isso dever ser pego atravs do programa, 
	janela ou mesmo arquivo.
    */ 
    public static void main (String args[]) 
    {
	/* Testa argumentos... */
	/*TODO: Pegar a descricao */
	if (args.length < 1) 
	    {
		System.out.println ("Modo de uso: jaco MUD.Cliente <ior_file>");
		System.exit (1);
	    }
	
	try 
	    {
		File f = new File (args[0]);
		
		/* checa se existe a entrada no disco */
		if (!f.exists ())
		    {
			System.out.println ("File " + args[0] + 
				   	    " does not exist.");               
			System.exit (-1);
		    }
		
		/* checa se args[0] eh um dir. */
		if (f.isDirectory ())
		    {
			System.out.println ("File " + args[0] + 
				   	    " is a directory.");               
			System.exit (-1);
		    }
		
		/* inicializa o ORB */
		ORB orb = ORB.init (args, null);
		
		BufferedReader br = new BufferedReader (new FileReader (f));
		
		/* pega a referencia do arquivo */
		String refctrl=br.readLine();
		
		/* Cria um objeto CORBA para o controle */
		org.omg.CORBA.Object obj = orb.string_to_object (refctrl);
		br.close ();
		
		/* e aplica um narrow pra pegar referencia pro objeto 
		   controle */
		Controle controle = ControleHelper.narrow (obj);
		
		/** Pega o POA*/
		POA poa = POAHelper.narrow (orb.resolve_initial_references ("RootPOA"));
		poa.the_POAManager ().activate ();
		/* Cria o Avatar. Aqui seria interessante ler a descricao
		   do Avatar a partir de um arquivo, bem como o nome do 
		   mesmo e fazer um prompt para a senha e autenticar o 
		   infeliz
		*/
		/* TODO: Autenticacao/Mudar a descricao */
		int id_aut=controle.Autenticar(args[1],args[2]);
		if (id_aut==0)
		{
		   System.out.println("Nao foi possivel autenticar seu usuario");
		   System.exit(1);
		}
		System.out.println("Usuario Autenticado");  
		UsuarioImpl avatar=new UsuarioImpl(orb,"Eu sou um avatar comum e desprezivel",refctrl,args[1]);
		/* Pega a referencia para a Clareira no controle */
		String sala_ini=controle.PegarSala(1);
		/* Instancia a Clareira (OD) */
		org.omg.CORBA.Object obj3=orb.string_to_object(sala_ini);
		Sala s_ini=SalaHelper.narrow(obj3);
		/* Obtem a referencia string para este avatar */
		org.omg.CORBA.Object obj2 = poa.servant_to_reference (avatar);
		/* Entra na sala. Como se trata da clareira, nao preciso 
		   testar se eu tenho permissao para fazer isso
		*/
		s_ini.EntrarSala(args[1],orb.object_to_string(obj2));
		/* Instancio o interpretador. Futuramente a ser substituido 
		   por uma interface grfica
		*/
		Interpretador intr=new Interpretador(orb,orb.object_to_string (obj2),args[1],id_aut,refctrl);
		intr.start();
		orb.run();
	    }
	catch (Exception e) 
	    {
		/* TODO: Colocar mensagem de erro mais amigavel */
		e.printStackTrace ();
		System.out.println (e.toString());
	    }
    }
}




