/* MAC 440 - EP 3 - "MUD Distribuido (TCB)"
   
   Nomes: Andr Gustavo Andrade         #3117621
          Julio Cesar Avero             #3188339
   
   Ferramentas: JacORB1_4_beta2, jakarta-ant-1.4.1, j2sdk1.4.0
   
   Data Incio:            15/06
   Data Ultima Alterao:  4/07
*/

/* TODO: --> Parte referente aos objetos (X)
         --> Leitor de arquivo
         --> Inicializador Padrao
             --> Criacao da Entrada para Clareira
	     --> Criacao da Entrada para Wizard
*/
package MUD;

import java.lang.*;
import java.util.*;
import org.omg.PortableServer.POA;
import org.omg.CORBA.*;

/** Classe que implementa o servante de controle do MUD */
public class ControleImpl
    extends ControlePOA
{  
    Repositorio salas;
    Repositorio usuarios;
    ORB orb;
    POA poa;
    
    /** Construtor da classe controle 
	@param opc Opcao. Descreve se o controle deve fazer a inicializacao 
	bsica, o que deve ser feito quando rodado pela primeira 
	vez ou se deve ler as configuraes a partir de um 
	arquivo.
	@param clarref Referencia para a sala Clareira criada pelo servidor.
    */
    public ControleImpl(String opc, String clarref, ORB orbinho, POA p)
    {
	salas=new Repositorio();
	usuarios=new Repositorio();
	/* DEBUG:
	   System.out.println("Clarref: "+clarref);
	*/
	CriarSala (new String("Clareira"), clarref, 1);
	CriarUsuario ("wizard", "123");
	orb=orbinho;
	poa=p;
    }
    
    /** Efetiva o ato de pegar um objeto 
	@param id Identificador do objeto
	@return String contendo todos os dados do objeto de forma a 
	permitir que este reencarne em outro lugar
    */
    public java.lang.String ConcluirPegarObjeto(int id)
    {
	return null;
    }
    
    /** Executado quando um usuario necessita abandonar o sistema
	@param id Identificador do usuario
    */
    public void Sair(int id)
    {
	/* MAYBE_DONE: Nao se remove entrada do usuario, apenas modifica-o para 
	   offline. URGENTE
	*/
	usuarios.AlterarCampo((long) id, 3, "0");
    }
    
    /** Executa a destruicao de uma sala
	@param nome Nome do usuario que estah tentando destruir a sala
	@param nomedasala Nome da sala que se pretende destruir
    */
    public void DestruirSala(java.lang.String nome, java.lang.String nomedasala)
    {
	/* TODO: Implementar destruicao da sala */
    }
    
    /** Informa o controle do desejo de sair da sala
	@param saida Por qual saida pretende-se sair
    */ 
    public void SairSala(int usr, java.lang.String saida)
    {
	/* TODO: Implementar Sair da Sala por alguma saida. Muito 
	   provavelmente essa funcao caia fora daqui e da IDL porque o 
	   controle nao precisa rastrear usuarios
	*/
    }
    
    /** Teleporta um usuario para uma certa sala
	@param nome Nome do usuario
	@param nomesala Nome da sala
	@return <code>0</code> Caso seja mal sucedido em fazer o teleporte, 
	e <code>!=0</code> Caso tenha sido bem sucedido, onde o 
	valor retornado representa o identificador da sala.
    */
    public int Teleporte(java.lang.String nome, java.lang.String nomesala)
    {
	/* TODO: Implementar Teleporte */
	return 0;
    }
    
    /** Cria uma sala
	@param nome Nome do usuario que pretende criar a sala
	@param ref Referencia da sala criada
	@param nomesala Nome da sala a ser criada
	@return Id da sala criada ou <code>-1</code> em caso de erro.
    */
    public int CriarSala(java.lang.String nome, java.lang.String ref, int quemcriou)
    {
	/* TODO: Se a referencia for vazia, entao eu mesmo crio a sala. A 
	   referencia da mesma podera ser acessada por PegarSala
	   MAYBE_DONE: Retornar o ID da sala, e nao 0 */
	
	String tmp=new String("");
	if (!tmp.equals(ref))
	{
	   tmp=tmp.concat(nome);
	   tmp=tmp.concat(new String("\n"));
	   tmp=tmp.concat(ref);
	   tmp=tmp.concat(new String("\n"));
	   tmp=tmp.concat(Integer.toString(quemcriou));
	   tmp=tmp.concat(new String("\n"));   
	
	   return (int) salas.Inserir(tmp);
	}
	else
	{
	   /* DEBUG:
	   System.out.println("Bostinha");
	   */
	   java.lang.Object trava=new java.lang.Object();
	   int id_sala=0;
	   tmp=tmp.concat(nome);
	   tmp=tmp.concat(new String("\n"));
	   tmp=tmp.concat(ref);
	   tmp=tmp.concat(new String("\n"));
	   tmp=tmp.concat(Integer.toString(quemcriou));
	   tmp=tmp.concat(new String("\n"));   
	
	   id_sala=(int)salas.Inserir(tmp);
	   Encarna n_sala = new Encarna(orb,quemcriou,id_sala,trava,poa);
	   n_sala.start();
	   synchronized(trava)
	   {
	      try
	      {
	         while(n_sala.pronto==false) trava.wait();
	      }
	      catch(InterruptedException ie)
	      {
	         trava.notify();
	      }
	   }
	   salas.AlterarCampo ((long) id_sala, 2, n_sala.ref);
	   return id_sala;
	}
    }
    
    /** Autentica um usuario para que ele possa a fazer parte do sistema
	@param nome Nome do usuario
	@param senha Senha relativa a esse usuario
	@return <code>0</code> Caso seja mal sucedido e o id do usuario
	caso tenha sido bem sucedido
    */
    public int Autenticar(java.lang.String nome, java.lang.String senha)
    {
	long[] ids = usuarios.PegarId (nome, 1);
	if (ids == null) return 0;
	
	long id = ids[0];
	String senhaReal = usuarios.PegarCampo (id, 2);
	if (senhaReal.compareTo (senha) == 0) 
	{
		usuarios.AlterarCampo (id, 3, "1");
		return (int) id;
	}
	else return 0;
    }
    
    /** Tenta pegar um objeto
	@param id Identificador do objeto
	@return 1 caso seja bem sucedido e 0 caso contrario 
    */
    public int PedirPegarObjeto(int id)
    {
	return 0;
    }
    
    /** Destroi um usuario
	@param nome Nome do usuario que esta tentando destruir o usuario
	@param nomedousuario Nome do usuario a ser destruido
    */ 
    public void DestruirUsuario(java.lang.String nome, java.lang.String nomedousuario)
    {
	/* JA: Varzea total, pois deveria verificar se eh o wizard
	   AA: Mais varzea ainda, porque nem o wizard deve poder remover 
	   o wizard
	*/
	long[] ids = usuarios.PegarId(nomedousuario, 1);
	usuarios.Remover (ids[0]);
    }
    
    /** Larga um objeto numa sala
	@param sala Nome da sala
	@param id Identificador do objeto
	@return 1 se bem sucedido e 0 caso contrario
    */
    public int LargarObjeto(java.lang.String sala, int id)
    {
	return 0;
    }
    
    /** Destroi objeto
	@param id Identificador do objeto
	@return 1 se for bem sucedido e 0 caso contrario
    */
    public int DestruirObjeto(int id)
    {
	return 0;
    }
    
    /** Criar usuario
	@param nome Nome do usuario a ser criado
	@param senha Uma senha para dado usuario. Como quem pode criar usuarios 
	eh somente o wizard e somente ele pode destrui-los, e 
	pode faze-lo incondicionalmente, nao faz mal que ele 
	conheca a senha de cada um dos usuarios
	@return id do usuario
    */
    public int CriarUsuario(java.lang.String nome, java.lang.String senha)
    {
	/* MAYBE_DONE: Retornar ID do usuario */
	String tmp=new String("");
	tmp=tmp.concat(nome);
	tmp=tmp.concat(new String("\n"));
	tmp=tmp.concat(senha);
	tmp=tmp.concat(new String("\n"));
	tmp=tmp.concat(new String("0\n")); //status do usuario no sistema (online ou nao)
	return (int) usuarios.Inserir (tmp);
    }
    
    /** Cria um objeto.
	@param ref Referencia desse objeto.
	@return 1 caso seja bem sucedido, 0 caso contrario.
    */
    public int CriarObjeto(java.lang.String ref)
    {
	return 0;
    }
    
    /** Retorna a referencia da sala desejada.
	@param id Identificador da sala no sistema.
	@return algo diferente de <b>null</b> se sala existe, <b>null</b> caso contrrio.
    */
    public java.lang.String PegarSala(int id)
    {
	/* DEBUG:
	   System.out.println("Controle Pegar Sala A ok");
	*/
	return salas.PegarCampo (id, 2);
    }
}
