/* MAC 440 - EP 3 - "MUD Distribuido (TCB)"

   Nomes: Andr Gustavo Andrade         #3117621
          Julio Cesar Avero             #3188339

   Ferramentas: JacORB1_4_beta2, jakarta-ant-1.4.1, j2sdk1.4.0
   
   Data Incio:            15/06
   Data Ultima Alterao:  4/07
*/

package MUD;
import java.io.*;
import java.lang.*;
import java.util.*;
import org.omg.PortableServer.*;
import org.omg.CORBA.*;

/** Esta classe estende uma thread que fica numa espera infinita unicamente 
   para encarnar uma sala, criada pelo controle
*/
public class Encarna extends Thread
{
   /** Referencia para a sala servante */
   public String ref;
   /** Sala servante */
   SalaImpl sala;
   /** ORB da maquina */
   ORB orb;
   /** Quem criou a sala */
   int quem;
   /** Tipo da sala */
   int tip;
   /** Identificador da sala */
   int id;
   /** Diz se a sala deve ou nao continuar existindo */
   boolean existente;
   /** Diz se a criacao da sala jah ocorreu */
   boolean pronto;
   /** Objeto que serve como variavel de condicao ao monitor implementado */
   java.lang.Object trava;
   /** POA */
   POA poa;
   
   /** Construtor da classe encarna
      @param o ORB
      @param q Quem criou a sala
      @param id_sal Identificador da sala
      @param t Objeto que serve de trava
      @param p POA
   */
   public Encarna(ORB o, int q, int id_sal, java.lang.Object t, POA p)
   {
      orb=o;
      pronto=false;
      existente=true;
      trava=t;
      quem=q;
      tip=1;
      id=id_sal;
      poa=p;
   }
   
   /** Efetivamente cria a sala */
   public void run()
   {
      java.lang.Object lixo = new java.lang.Object();
      sala=new SalaImpl(quem,1,id,orb,new String("Sala criada"));
      try
      {
         //POA poa = POAHelper.narrow (orb.resolve_initial_references ("RootPOA"));
         org.omg.CORBA.Object obj2=poa.servant_to_reference(sala);
         ref=orb.object_to_string(obj2);
         pronto=true;
         synchronized(trava)
         {
            trava.notify();
         }
         synchronized(lixo)
         {
            lixo.wait();
         }
         
      }
       catch (Exception e) 
	    {
		e.printStackTrace ();
		System.err.println (e.toString());
	    }         
   }
   
}