/* MAC 440 - EP 3 - "MUD Distribuido (TCB)"

   Nomes: Andr Gustavo Andrade         #3117621
          Julio Cesar Avero             #3188339

   Ferramentas: JacORB1_4_beta2, jakarta-ant-1.4.1, j2sdk1.4.0
   
   Data Incio:            15/06
   Data Ultima Alterao:  4/07
*/
/* TODO: Implementar 
         -->Listar usuarios
	 -->Mudar descricao do Avatar
	 -->Mudar Descricao da Sala
	 -->Criar saida
	 -->Listar Saida
*/
package MUD;
import java.lang.*;
import java.util.*;
import org.omg.PortableServer.*;
import org.omg.CORBA.*;


/** Classe responsavel por interpretar os comandos da linha de comando */
class Interpretador extends Thread
{
    /** rimeiro parametro */
    public String param1;
    /** egundo parametro */
    public String param2;
    
    /** ORB CORBA presente nesta maquina */
    ORB orb;
    /** Referencia (string) Para o avatar encarnado por este usuario */
    String avatarref;
    /** Instanciacao do OD representando o Avatar */
    Usuario usr;
    /** Nome do Avatar */
    String nome;
    /** Buffer temporario para captacao de teclas do teclado */
    byte buffer[]=new byte[1000];
    /** Identificador do Avatar */
    int ident;
    /** String referencia para o controle */
    String ctrl;
    /** Controle */
    Controle controle;
    
    
    /** Construtor do Interpretador
	@param orbinho ORB presente na maquina
	@param userref Referencia para o OD que encarna o Avatar
	@param name Nome do Avatar
	@param id Identificador do Avatar
    */
    public Interpretador(ORB orbinho,String userref,String name, int id, String ctrl)
    {
	param1=null;
	param2=null;
	orb=orbinho;
	avatarref=userref;
	org.omg.CORBA.Object obj = orb.string_to_object(userref);
	usr = UsuarioHelper.narrow (obj);
	org.omg.CORBA.Object obj2 = orb.string_to_object(ctrl);
	controle = ControleHelper.narrow (obj2);
	nome=name;
	ident=id;
    }
    
    /** Interpreta os comandos de uma certa string 
	@param s String a ser interpretada
	@return Codigo da instrucao interpretada. Caso ela possua 
	        mais algum parametro alem da instrucao, esses parametros
		sao colocados nas variaveis <code>param1</code> e 
		<code>param2</code> 
    */
    public int get_command(String s)
    {
	/* TODO: Implementar novas opcoes */
	/* Manda uma mensagem para os Avatares na sala :1 param - msg*/
	if (s.indexOf("/msg ")!=-1)
	    {
		param1=s.substring(5,s.length()-1);
		return 1;
	    }
	
	/* Vai pra alguma saida :1 param - saida*/
	if (s.indexOf("/va ")!=-1)
	    {
		param1=s.substring(4,s.length()-1);
		return 2;
	    }
	
	/* Pega a descricao da sala */
	if (s.indexOf("/descsala")!=-1)
	    {
		return 3;
	    }
	
	/* Pede a descricao de um avatar :1 param - avatar*/
	if (s.indexOf("/descavatar ")!=-1)
	    {
		param1=s.substring(12,s.length()-1);
		return 4;
	    }
	
	/* Pede para listar as saidas */
	if (s.indexOf("/saidas")!=-1)
	    {
		return 5;
	    }
	    
	/* Pede para sair do programa */
	if (s.indexOf("/sair")!=-1)
	    {
		return 6;
	    }
	    
	/* Listar Usuarios */
	if (s.indexOf("/listavatares")!=-1)
	    {
		return 7;
	    }
	    
	/* Nova Descricao do meu Avatar :1 param - msg*/
	if (s.indexOf("/novadescricao ")!=-1)
	    {
		param1=s.substring(15,s.length()-1);
		return 8;
	    }
	
	/* Manda uma mensagem para os Avatares na sala :1 param - msg*/
	if (s.indexOf("/descricaosala ")!=-1)
	    {
		param1=s.substring(15,s.length()-1);
		return 9;
	    }
	    
	 /* Listar Usuarios */
	if (s.indexOf("/novasala ")!=-1)
	    {
	        /*TODO: Criar sala */
		return 10;
	    }
	       
	 /* Listar Usuarios */
	 if (s.indexOf("/listasaidas")!=-1)
	     {
	 	return 11;
	     }
	 
	 /* Criar um novo Avatar */
	 if (s.indexOf("/novoavatar ")!=-1)
	 {
	   param1=s.substring(12,s.length()-1);
	   return 12;
	 }
	 
	 /* para se criar uma sala a partir da atual */
	 if (s.indexOf("/criasala ")!=-1)
	    {
		param1=s.substring(10,s.length()-1);
		return 13;
	    }
	 
	 /* Imprimir Id da sala em que estou */
	 if (s.indexOf("/onde")!=-1)
	     {
	 	return 14;
	     }
	     
	 /* para se criar uma saida. Note, a sintaxe deve ser:
	     /criasaida #### nomesaida 
	     onde #### sao 4 numeros representando o id da sala. Se a sala 
	     tiver id=1, ####=0001
	  */
	 if (s.indexOf("/criasaida ")!=-1)
	    {
		param1=s.substring(11,15);
		param2=s.substring(16,s.length()-1);
		return 15;
	    }    
	/* Nenhuma opcao foi reconhecida */
	return -1;
    }	

    /** Esta funcao le uma sequencia de teclas do teclado ate que a tecla 
	enter seja pressionada
	@return String contendo a sequencia de letras digitadas
    */
    public String get_line()
    {
	int n=0;
	try
	    {
		n = System.in.read (buffer, 0, 1000);
	    }
	catch (Exception e)
	    {
		e.printStackTrace ();
		System.err.println (e.toString ());
	    }
	/* PS: O n-1 eh devido ao fato de querermos retirar o enter */
	return new String(buffer,0,n-1);
    }
    
    /** Esta funcao interpreta, tomando as atitudes necessarias quando 
	um comando for reconhecido
	@param i Comando
    */
    public void interp_command(int i)
    {
	/* Em caso de comando desconhecido... TESTED */
	if (i==-1)
	    {
		System.out.println("Comando Invalido");
		return;
	    }
	/* Se o comando for Enviar Mensagem... TESTED */
	if (i==1)
	    {
		String s;
		s=usr.PegarSala();
		/* TODO: Verificar casos hediondos*/
		org.omg.CORBA.Object obj = orb.string_to_object(s);
		Sala sala=SalaHelper.narrow(obj);
		sala.MandarMensagem(nome,param1);
	    }
	/* Se o comando for para Ir para algum lugar DONE */
	if (i==2)
	    {
		String s;
		int j;
		s=usr.PegarSala();
		/* TODO: Verificar casos hediondos*/
		org.omg.CORBA.Object obj = orb.string_to_object(s);
		Sala sala=SalaHelper.narrow(obj);
		j=sala.PegarSaida(param1);
		if (j==-1)
		{
		   System.out.println("Saida inexistente");
		}
		else  
		{
		   usr.MudarSala(ident,j,avatarref);
		}
	    }
	/* Se o comando for para Pegar descricao da sala... TESTED*/
	if (i==3)
	    {
		String s;
		/* DEBUG:
		   System.out.println("Interpretador: Comando 3 A ok");
		*/
		s=usr.PegarSala();
		/* DEBUG:
		   System.out.println("Interpretador: Comando 3 B ok");
		*/
		/* TODO: Verificar casos hediondos*/
		org.omg.CORBA.Object obj = orb.string_to_object(s);
		Sala sala=SalaHelper.narrow(obj);
		System.out.println(sala.PegarDescricao());
	    }
	/* Se o comando for para Pegar descricao de um Avatar... TESTED */
	if (i==4)
	    {
		String s;
		String g;
		s=usr.PegarSala();
		/* TODO: Verificar casos hediondos*/
		org.omg.CORBA.Object obj = orb.string_to_object(s);
		Sala sala=SalaHelper.narrow(obj);
		g=sala.PegarDescricaoUsuario(param1);
		System.out.println(g);
	    }
	/* Se o comando for Listar Saidas... DONE */
	if (i==5)
	    {
		String s;
		String g;
		s=usr.PegarSala();
		/* TODO: Verificar casos hediondos */
		org.omg.CORBA.Object obj = orb.string_to_object(s);
		Sala sala=SalaHelper.narrow(obj);
		g=sala.ListarSaidas();
		/* PS: Como saidas sao separadas por CR, nao preciso tomar 
		   nenhum tipo de providencia para tratar a impressao aqui
		*/
		System.out.println(g);
	    }
	 /* Se o comando for sair... DONE */
	 if (i==6)
	    {
	         System.out.println("Obrigado por usar o TCB - MUD");
	         String s=usr.PegarSala();
	         org.omg.CORBA.Object obj = orb.string_to_object(s);
 		 Sala sala=SalaHelper.narrow(obj);
 		 sala.SairSala (nome);
                 controle.Sair(ident);
	         System.exit(1);
	    }
	  /* Se o comando for listar avatares... DONE */
	  if (i==7)
	    {
		String s;
		String g;
		s=usr.PegarSala();
		/* TODO: Verificar casos hediondos*/
		org.omg.CORBA.Object obj = orb.string_to_object(s);
		Sala sala=SalaHelper.narrow(obj);
		g=sala.ListarUsuarios();
		System.out.println(g);
	    }     
	   /* Se o comando for mudar descricao do avatar... DONE */
	   if (i==8)
	     {
	         usr.MudarDescricao(param1);
	     }  
	   
	   /* Se o comando for listar avatares... DONE */
	   if (i==9)
	    {
		String s;
		String g;
		s=usr.PegarSala();
		/* TODO: Verificar casos hediondos*/
		org.omg.CORBA.Object obj = orb.string_to_object(s);
		Sala sala=SalaHelper.narrow(obj);
		sala.MudarDescricao(ident,param1);
	    }    
	    
	    /* Se o comando for criar nova sala... TODO */
	    if (i==10)
	    {
	      /* TODO: Implementar criacao de salas */
	    }
	    
	    /* Se o comando for listar saidas... DONE */
	    if (i==11)
	    {
		String s;
		String g;
		s=usr.PegarSala();
		/* TODO: Verificar casos hediondos*/
		org.omg.CORBA.Object obj = orb.string_to_object(s);
		Sala sala=SalaHelper.narrow(obj);
		g=sala.ListarSaidas();
		System.out.println(g);
	    }   
	    /* Se o comando for criar avatar */
	    if (i==12)
	    {
	      controle.CriarUsuario(param1,new String("234"));
	    }
	       
	    /* Se o comando for criar salas... DONE */
	    if (i==13)
	    {
		String s;
		int id_s;
		s=usr.PegarSala();
		/* TODO: Verificar casos hediondos*/
		org.omg.CORBA.Object obj = orb.string_to_object(s);
		Sala sala=SalaHelper.narrow(obj);
		id_s=controle.CriarSala(new String("teste"),new String(""),ident);
		sala.CriarSaida(id_s,param1);
		/* DEBUG:
		System.out.println("Sala criada");
		*/ 
		
	    }
	    
	    /* Se o comando for imprimir onde estou... */   
	    if (i==14)
	    {
	      int idsala;
	      idsala=usr.OndeEstou();
	      System.out.println("Sala: "+idsala);
	    }
	    
	    /* Se o comando for criar saidas... */
	    if (i==15)
	    {
	        String s;
		int idss;
		idss=Integer.parseInt(param1);
		/* TODO: Verificar se esse indice eh realmente valido junto 
		   ao controle
		*/
		s=usr.PegarSala();
		/* TODO: Verificar casos hediondos*/
		org.omg.CORBA.Object obj = orb.string_to_object(s);
		Sala sala=SalaHelper.narrow(obj);
		sala.CriarSaida(idss,param2);
	    }
	    

    }

    /** Rotina da thread que poem as coisas rodando bonitinho */
    public void run()
    {
	String s;
	int i;
	while(true)
	    {
		s=get_line();
		i=get_command(s);
		interp_command(i);
	    }
    }
}

