/* MAC 440 - EP 3 - "MUD Distribuido (TCB)"

   Nomes: Andr Gustavo Andrade         #3117621
          Julio Cesar Avero             #3188339

   Ferramentas: JacORB1_4_beta2, jakarta-ant-1.4.1, j2sdk1.4.0
   
   Data Incio:            15/06
   Data Ultima Alterao:  4/07
*/
/* TODO:
 */

package MUD;

import java.lang.*;
import java.util.*;
import org.omg.PortableServer.POA;
import org.omg.CORBA.*;

/** Classe servante que implementa uma sala do MUD */
public class SalaImpl
    extends SalaPOA
{
    /** Relaciona nomes com objetos Corba representando players */
    private Hashtable Avatares;
    /** Relaciona Saidas com os Ids das salas */
    private Hashtable Saidas;
    /** Descricao da Sala */
    private String Descricao;
    /** Id do criador da sala */
    private int Criador;
    /** Descreve quem pode entrar. Pode ser privativa (0) ou publica (1).
	Se privativa, soh o criador pode usar. Se for publica qualquer 
	um pode entrar.
    */
    private int tipo;
    /** Identificador da sala */
    private int id;
    /** ORB desta maquina */
    ORB orb;
	
    /** Construtor da Sala
	@param QuemCriou Identificador do Criador da Sala
	@param tip Tipo da sala
	@param ident Identificador do criador da sala
	@param o ORB presente na maquina
	@param desc Descricao inicial da sala
    */
    public SalaImpl(int QuemCriou, int tip, int ident, ORB o,String desc)
    {
	Avatares = new Hashtable ();
	Saidas = new Hashtable();
	Criador=QuemCriou;
	id=ident;
	orb=o;
	tipo=tip;
	Descricao=desc;
    }
		
    /** Largar Objeto
	@param id Identificador do usuario
	@param nome Nome do usuario
	@return <code>0</code> Caso nao seja bem sucedido e 
	        <code>1</code> caso contrario
    */
    public int LargarObjeto(int id, java.lang.String nome)
    { 
	return 0;
    }

    /** Cria uma saida na sala 
	@param id Identificador da sala destino
	@param nome Nome da saida
	@return <code>1</code> caso tenha tido sucesso, 
	        <code>0</code> caso contrario
    */
    public int CriarSaida(int id, java.lang.String nome)
    {
	Saidas.put((String)nome,new Integer(id));
	return 1;
    }

    /** Pegar Descricao de um objeto 
     @param objeto Nome do objeto
     @return Retorna a descricao de um objeto
   */
    public java.lang.String PegarDescricaoObjeto(java.lang.String objeto)
    {
	return null;
    }

    /** Manda Mensagem  para todos os que estao presentes na sala
	@param nome Nome do usuario que estah enviando a mensagem
	@param msg Mensagem a ser enviada
	@return <code>0</code> Caso nao tenha sido possivel e 
	        <code>1</code> Caso tenha tido sucesso
    */
    public int MandarMensagem(java.lang.String nome, java.lang.String msg)
    {
        /* DEBUG:
	System.out.println("Mandar Mensagem chamada");
	*/
	if (!Avatares.containsKey ((String) nome)) return 0;
	for (Enumeration e = Avatares.keys () ; e.hasMoreElements () ;) 
	    {
		String usuario = (String) (e.nextElement ());
		String obj=(String)Avatares.get(usuario);
		org.omg.CORBA.Object obj2 = orb.string_to_object(obj);
		Usuario usr = UsuarioHelper.narrow (obj2);
		usr.ImprimirMensagem(msg);
	    }
	return 1;
    }

    /** Pede para pegar um objeto
	@param nome Nome do objeto 
	@return <code>0</code> Caso nao seja possivel, 
                <code>1</code> Caso seja possivel.
    */
    public int PedirPegarObjeto(java.lang.String nome)
    {
	return 0;
    }

    /** Destroi uma saida
     @param id Identificador do usuario que estah tentando destruir a sala
     @param nomesaida Nome da saida que se quer destruir
     @return <code>1</code> caso seja bem sucedido e 
             <code>0</code> caso contrario
   */
    public int DestruirSaida(int id, java.lang.String nomesaida)
    {
	if (id==Criador)
	    {
		if (!Avatares.containsKey ((String) nomesaida)) return 0;
		Saidas.remove((String)nomesaida);
		return 1;
	    }
	return 0;
    }

    /** Muda a descricao de uma sala
     @param id Identificador do usuario que estah tentando mudar a descricao
     @param descricao Nova descricao da sala
     @return <code>1</code> Caso tenha tido sucesso e 
             <code>0</code> caso contrario
   */
    public int MudarDescricao(int id, java.lang.String descricao)
    {
	if (id==Criador)
	    {
		Descricao=descricao;
		return 1;
	    }
	return 0;
    }

    /** Aciona um verbo de um objeto na sala
     @param verbo Nome do verbo que se pretende acionar
     @param objeto Nome do objeto sobre o qual se pretende agir
     @return <code>1</code> caso tenha sido bem sucedido e 
             <code>0</code> caso contrario
   */
    public int AcionarVerboObjeto(java.lang.String verbo, java.lang.String objeto)
    {      
	return 0;
    }

    /** Conclui pegar objeto. DEVE ser chamada depois de um PedirPegarObjeto 
      bem sucedido.
      @param nome Nome do objeto
      @return Uma string contendo a descricao completa do objeto para que 
              ele possa ser encarnado em outro lugar
   */ 
    public java.lang.String ConcluirPegarObjeto(java.lang.String nome)
    { 
	return null;
    }

    /** Lista os objetos da sala
      @return Uma string contendo o nome de todos os usuarios separados 
              por \n
   */
    public java.lang.String ListarUsuarios()
    {
	String Lista=new String("");
    	for (Enumeration e = Avatares.keys() ; e.hasMoreElements() ;)   
	    {
		String Avatar = (String) (e.nextElement ());
		Lista = Lista.concat (Avatar+"\n");
	    }
	return Lista;
    }

    /** Sai oficialmente desta sala
      @param nome Nome do usuario que pretende sair dessa sala
      @return <code>1</code> caso tenha sido bem sucedido e 
              <code>0</code> caso contrario
   */
    public int SairSala(java.lang.String nome)
    {
      /* DEBUG:   
        System.out.println("Nome: "+nome);

for (Enumeration e = Avatares.keys() ; e.hasMoreElements() ;)   
{
System.out.println("argh: "+ ((String) (e.nextElement ())));
}       
*/
	if (!Avatares.containsKey ((String) nome)) return 0;
	Avatares.remove(nome); 
/* DEBUG:
for (Enumeration e = Avatares.keys() ; e.hasMoreElements() ;)   
{
System.out.println("orgh: "+ ((String) (e.nextElement ())));
}
*/
	
	return 1;
    }

    /** Pega a descricao de um usuario presente na sala
      @param nome Nome do usuario da sala cuja descricao pretende-se pegar
      @return descricao
   */
    public java.lang.String PegarDescricaoUsuario(java.lang.String nome)
    {
	if (!Avatares.containsKey ((String) nome)) 
	    {
		return new String("A sala nao possui este usuario");
	    }
	java.lang.String obj;
	obj=(String)Avatares.get((String)nome);
	org.omg.CORBA.Object obj2 = orb.string_to_object(obj);
	Usuario usr = UsuarioHelper.narrow (obj2);
	return usr.PegarDescricao();
    }

    /** Entra na sala. O usuario passa seu nome e a referencia para seu 
      objeto
      @param nome Nome do usuario
      @param ref Referencia do objeto
      @return <code>1</code> caso tenha sido bem sucedido e 
              <code>0</code> caso contrario
   */
    public int EntrarSala(java.lang.String nome, java.lang.String ref)
    {
        /* DEBUG:
	System.out.println("Entrar Sala chamado");
	*/
	if (Avatares.containsKey ((String) nome)) return 0;     
	Avatares.put ((String) nome, (String)ref);
	return 1;
    }

    /** Lista todos os objetos presentes na sala
     @return Uma string contendo o nome de todos os objetos
   */
    public java.lang.String ListarObjetos()
    {   
	/* TODO: Cuidado aqui! Isso dah pau no CORBA! */
	return null;
    }

    /** Listar todas as saidas da sala
     @return Uma string contendo todas as saidas da sala
   */ 
    public java.lang.String ListarSaidas()
    {
	String Lista=new String("");
    	for (Enumeration e = Saidas.keys() ; e.hasMoreElements() ;)   
	    {
		String Saida = (String) (e.nextElement ());
		Lista = Lista.concat (Saida+"\n");
	    }
	return Lista;
    }

    /** Retorna a descricao da sala
     @return Descricao da sala
   */
    public java.lang.String PegarDescricao()
    {
        /* DEBUG: 
	System.out.println("Estou pegando a punheta da descricao");
	*/
	String tmp=new String(Descricao);
	return tmp;
    }

    /** Retorna se uma dada pessoa tem permissao para entrar nessa sala
      @param id Identificador da pessoa
      @return <code>1</code> Caso seja permitido entrar na sala, 
              <code>0</code> caso contrario
   */
    public int PossoEntrar(int id)
    {
	if (tipo==0)
	    {
		if (Criador==id) return 1;
		return 0;
	    }
	return 1;
    }

    /** Lista os verbos de um objeto presente na sala
      @param objeto Nome do objeto cujos verbos pretende-se listar
      @return String contendo uma lista de verbos separados.
    */
    public java.lang.String ListarVerbosObjeto(java.lang.String objeto)
    {
	return null;
    }

    /** Pega o id da sala apontada por uma saida
      @param saida Noma da saida
      @return Identificador da sala para o qual a saida aponta
    */
    public int PegarSaida(java.lang.String saida)
    {
	if (!Saidas.containsKey ((String) saida)) return -1;
	return ((Integer)Saidas.get((String)saida)).intValue();
    }

}
