/* MAC 440 - EP 3 - "MUD Distribuido (TCB)"

   Nomes: Andr Gustavo Andrade         #3117621
          Julio Cesar Avero             #3188339

   Ferramentas: JacORB1_4_beta2, jakarta-ant-1.4.1, j2sdk1.4.0
   
   Data Incio:            15/06
   Data Ultima Alterao:  4/07
*/
/* TODO:
 */

package MUD;

import java.io.*;
import java.lang.*;
import java.util.*;
import org.omg.PortableServer.*;
import org.omg.CORBA.*;

/** Classe responsavel por inicializar o objeto controle e a sala clareira, 
   bem como outras salas se especificado 
*/
public class Servidor {

    /** Rotina principal. Pega os argumentos na linha de comando e instancia 
	ao menos uma sala (A Clareira) e o Controle. Deve ser rodado antes que 
	os cliantes possam comecar a se conectar, ou seja, os avatares a 
	encarnar.
	@param args Argumentos da linha de comando. <code> args[0] </code> 
	deve contem o nome do arquivo onde a referencia do objeto 
	controle deve ser gravada.
	<code>args[1]</code> deve conter a opcao de inicializacao 
	do controle
    */
    public static void main (String[] args) 
    {
        if (args.length < 2 ) 
	    {
		System.out.println ("Uso: jaco MUD.Servidor <ior_file> opc");
		System.exit( 1 );
	    }        
        try 
	    {
		/* inicializa o ORB */
		ORB orb = ORB.init (args, null);
           
  	        /* inicializa o POA */
  	        POA poa = POAHelper.narrow (orb.resolve_initial_references ("RootPOA"));
	        poa.the_POAManager ().activate ();
	        
		ControleImpl controleImpl;
		org.omg.CORBA.Object obj;
           
           
		/* Criar sala no controle */
		SalaImpl sala1=new SalaImpl(1,1,0,orb,new String("Sala tosca 1"));
		org.omg.CORBA.Object obj2=poa.servant_to_reference(sala1);
		String sref=orb.object_to_string(obj2);
	
		/* DEBUG: Salas Espurias, soh de teste.... 
		SalaImpl sala2=new SalaImpl(0,0,1,orb,new String("Sala tosca 2"));
		SalaImpl sala3=new SalaImpl(0,0,2,orb,new String("Sala tosca 3"));
		SalaImpl sala4=new SalaImpl(0,0,3,orb,new String("Sala tosca 4"));           
               */
               
		/* Cria um controle */
		controleImpl = new ControleImpl (args[1],sref,orb,poa);	
		/* Cria a referencia para o objeto Controle */
		obj = poa.servant_to_reference (controleImpl);
		/* Imprime o objeto stringficado para um arquivo */
		PrintWriter pw = new PrintWriter (new FileWriter (args[0]));         
		pw.println (orb.object_to_string (obj));
		pw.flush ();         
		pw.close ();
             
		/* Aguarda requisicoes */
	        orb.run ();   
	    }
        catch (Exception e) 
	    {
		e.printStackTrace ();
		System.err.println (e.toString());
	    }     
    }
}



