/* MAC 440 - EP 3 - "MUD Distribuido (TCB)"

   Nomes: Andr Gustavo Andrade         #3117621
          Julio Cesar Avero             #3188339

   Ferramentas: JacORB1_4_beta2, jakarta-ant-1.4.1, j2sdk1.4.0
   
   Data Incio:            15/06
   Data Ultima Alterao:  4/07
 */
package MUD;

import java.lang.*;
import java.util.*;
import org.omg.PortableServer.POA;
import org.omg.CORBA.*;

/** Classe que implementa o servante do Usuario (Avatar) do MUD */
public class UsuarioImpl
    extends UsuarioPOA
{
    /** Descricao do Usuario */
    private String Descricao;
    /** Identificador da sala em que o usuario estah no momento */
    private int idsala;
   
    String nome;
    private ORB orb;
    private String controlestr;
    private Controle controle;   
    /** Construtor da classe usuario 
      @param dsc Descricao inicial do usuario. Mudar a IDL para conter 
         modificacao da descricao do usuario.
   */
    public UsuarioImpl(ORB orbinho, String dsc, String ctrlref, String name)
    {
	Descricao=dsc;
	controlestr=ctrlref;
	orb=orbinho;
	idsala=1;
	org.omg.CORBA.Object obj = orb.string_to_object(ctrlref);
	//Tratar de erros toscos
	controle=ControleHelper.narrow(obj);
	nome=name;
    }
		
    /** Devolve a descricao de um usuario (Avatar)
	  @return Descricao do usuario
	*/
    public java.lang.String PegarDescricao()
    {
	return Descricao;
    }

    /** Imprime uma mensagem
     @param msg Mensagem a ser impressa  
    */
    public void ImprimirMensagem(java.lang.String msg)
    {  
        /* DEBUG:
	System.out.println("Usuario Imprimir Mensagem chamada");
	*/
	System.out.println(msg);
    }

    /** Muda um player de sala 
      @param quem Identificador do Avatar que tenta entrar na sala.
      @param id Identificador da nova sala
      @param aref Referencia do avatar que esta tentando entrar na sala
   */
    public void MudarSala(int quem, int id, java.lang.String aref)
    {  
        /*MAYBE_DONE: Verificar se pode entrar na sala
                Sair da sala atual
                Entrar na nova sala
        */
    	String ref = controle.PegarSala (idsala);
    	org.omg.CORBA.Object obj = orb.string_to_object(ref);
	Sala sala = SalaHelper.narrow(obj);
	
	if (sala.PossoEntrar (quem) == 1) 
	{
	   int a=sala.SairSala(nome);
	   /* DEBUG:
	   System.out.println("Saiu? "+a);
	   */
	   idsala=id;
	   String ref2 = controle.PegarSala (id);
    	   org.omg.CORBA.Object obj2 = orb.string_to_object(ref2);
	   Sala sala2 = SalaHelper.narrow(obj2);
	   sala2.EntrarSala(nome,aref);
	}
	 
    }

    /** Esta rotina retorna a referencia para a sala na qual o avatar estah
      @return Referencia para a sala
     */
    public java.lang.String PegarSala()
    {
	/* Retornar a funcao do controle para pegar a referencia de uma sala
	   tendo-se o id da mesma */
	String g;
	/* DEBUG:
	System.out.println("Usuario Impl A ok");
	*/
	g=controle.PegarSala(idsala);
	/* DEBUG:
	System.out.println("Usuario Impl B ok. Ref: "+g);
	*/
	//Tratar sala invalida ou coisa parecida
	return g; 
    }
    
    /** Muda a descricao do usuario
       @param ndesc Nova descricao do usuario
    */
    public void MudarDescricao(java.lang.String ndesc)
	{
            Descricao=ndesc;
	}

   /** Retorna o id da sala na qual estah o avatar
      @return Id da sala em que estah o avatar
    */
    public int OndeEstou()
    {
       return idsala;
    }
   
}
